import { Controller } from '@hotwired/stimulus';
import { getComponent } from '@symfony/ux-live-component';

/*
* The following line makes this controller "lazy": it won't be downloaded until needed
* See https://symfony.com/bundles/StimulusBundle/current/index.html#lazy-stimulus-controllers
*/

/* stimulusFetch: 'lazy' */
export default class extends Controller {

    async initialize() {
        this.component = await getComponent(this.element);
        this.component.on('render:finished', (component) => {
            console.log(component);
        });
        if (window.location.hash) {
            let targetElement = document.querySelector(window.location.hash);
            if (targetElement) {
                targetElement.scrollIntoView({ behavior: 'smooth', block: 'start' });
                targetElement.classList.add('animate__animated', 'animate__pulse', 'animate__faster');
            }
        }
    }

    setSeason(season) {
        this.element.querySelectorAll(".episode-container").forEach(element => element.remove());
        this.component.set('pageNumber', 1);
        this.component.set('season', parseInt(season));
        this.component.render();
    }

    paginate(event) {
        this.element.querySelectorAll(".episode-container").forEach(element => element.remove());
        this.component.set('episodeNumber', null);
        this.component.action('paginate', {page: event.params.page});
        this.component.render();
    }

    connect() {
        // Called every time the controller is connected to the DOM
        // (on page load, when it's added to the DOM, moved in the DOM, etc.)

        // Here you can add event listeners on the element or target elements,
        // add or remove classes, attributes, dispatch custom events, etc.
        // this.fooTarget.addEventListener('click', this._fooBar)
    }

    // Add custom controller actions here
    // fooBar() { this.fooTarget.classList.toggle(this.bazClass) }

    disconnect() {
        // Called anytime its element is disconnected from the DOM
        // (on page change, when it's removed from or moved in the DOM, etc.)

        // Here you should remove all event listeners added in "connect()" 
        // this.fooTarget.removeEventListener('click', this._fooBar)
    }
}
